'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AccordionItem = require('./AccordionItem');

var _AccordionItem2 = _interopRequireDefault(_AccordionItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Accordion = function (_React$Component) {
  _inherits(Accordion, _React$Component);

  function Accordion(props) {
    _classCallCheck(this, Accordion);

    var _this = _possibleConstructorReturn(this, (Accordion.__proto__ || Object.getPrototypeOf(Accordion)).call(this, props));

    _this.toggleSection = _this.toggleSection.bind(_this);

    _this.state = { open: props.selected };
    return _this;
  }

  _createClass(Accordion, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ open: nextProps.selected });
    }
  }, {
    key: 'toggleSection',
    value: function toggleSection(index) {
      var allowMultiple = this.props.allowMultiple;

      var newOpenArray = [].concat(_toConsumableArray(this.state.open));

      if (newOpenArray.includes(index)) {
        newOpenArray = newOpenArray.filter(function (item) {
          return item !== index;
        });
      } else {
        newOpenArray = allowMultiple ? [].concat(_toConsumableArray(newOpenArray), [index]) : [index];
      }

      this.setState({ open: newOpenArray });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var open = this.state.open;

      var accordionItems = _react2.default.Children.map(this.props.children, function (child, index) {
        return _react2.default.cloneElement(child, {
          index: index,
          isOpen: open.includes(index),
          onClick: _this2.toggleSection
        });
      });

      return _react2.default.createElement(
        'aside',
        { className: 'p-accordion', role: 'tablist' },
        _react2.default.createElement(
          'ul',
          { className: 'p-accordion__list' },
          accordionItems
        )
      );
    }
  }]);

  return Accordion;
}(_react2.default.Component);

Accordion.defaultProps = {
  children: null,
  selected: [],
  allowMultiple: false
};

Accordion.propTypes = {
  children: function children(props, propName, componentName) {
    var prop = props[propName];
    var error = null;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type !== _AccordionItem2.default) {
        error = new Error(componentName + ' children should be of type "AccordionItem".');
      }
    });

    return error;
  },
  selected: _propTypes2.default.arrayOf(_propTypes2.default.number),
  allowMultiple: _propTypes2.default.bool
};

Accordion.displayName = 'Accordion';

exports.default = Accordion;