'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AccordionItem = function AccordionItem(props) {
  var isOpen = props.isOpen,
      _onClick = props.onClick,
      index = props.index,
      title = props.title,
      children = props.children;


  return _react2.default.createElement(
    'li',
    { className: 'p-accordion__group' },
    _react2.default.createElement(
      'button',
      {
        className: 'p-accordion__tab',
        id: 'accordion-button-' + index,
        role: 'tab',
        'aria-controls': 'accordion-content-' + index,
        'aria-expanded': isOpen,
        onClick: function onClick() {
          return _onClick(index);
        },
        onKeyDown: function onKeyDown(key) {
          return key === 'Enter' && _onClick(index);
        }
      },
      title
    ),
    _react2.default.createElement(
      'section',
      {
        className: 'p-accordion__panel',
        id: 'accordion-content-' + index,
        role: 'tabpanel',
        'aria-hidden': !isOpen,
        'aria-labelledby': 'accordion-button-' + index
      },
      children
    )
  );
};

AccordionItem.defaultProps = {
  index: 0,
  isOpen: false,
  onClick: function onClick() {
    return 1;
  }
};

AccordionItem.propTypes = {
  index: _propTypes2.default.number,
  title: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.element.isRequired,
  isOpen: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

AccordionItem.displayName = 'AccordionItem';

exports.default = AccordionItem;