'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BlockQuote = function BlockQuote(props) {
  if (props.pull) {
    return _react2.default.createElement(
      'blockquote',
      { className: 'p-pull-quote' },
      _react2.default.createElement(
        'p',
        null,
        props.quote
      ),
      _react2.default.createElement(
        'cite',
        { className: 'p-pull-quote__citation' },
        props.citation
      )
    );
  }

  return _react2.default.createElement(
    'blockquote',
    null,
    _react2.default.createElement(
      'p',
      null,
      _react2.default.createElement(
        'span',
        null,
        '"'
      ),
      props.quote,
      _react2.default.createElement(
        'span',
        null,
        '"'
      )
    ),
    _react2.default.createElement(
      'p',
      null,
      _react2.default.createElement(
        'cite',
        null,
        props.citation
      )
    )
  );
};

BlockQuote.defaultProps = {
  citation: '',
  pull: false
};

BlockQuote.propTypes = {
  quote: _propTypes2.default.string.isRequired,
  citation: _propTypes2.default.string,
  pull: _propTypes2.default.bool
};

BlockQuote.displayName = 'BlockQuote';

exports.default = BlockQuote;