'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this));

    _this.onClick = _this.onClick.bind(_this);
    return _this;
  }

  _createClass(Button, [{
    key: 'onClick',
    value: function onClick(event) {
      var _props = this.props,
          disabled = _props.disabled,
          onClick = _props.onClick;


      if (disabled) {
        event.preventDefault();
        return;
      }

      if (onClick) {
        onClick(event);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props2 = this.props,
          children = _props2.children,
          className = _props2.className,
          value = _props2.value,
          disabled = _props2.disabled,
          href = _props2.href,
          positive = _props2.positive,
          negative = _props2.negative,
          brand = _props2.brand,
          neutral = _props2.neutral,
          inline = _props2.inline,
          otherProps = _objectWithoutProperties(_props2, ['children', 'className', 'value', 'disabled', 'href', 'positive', 'negative', 'brand', 'neutral', 'inline']);

      var Tag = href ? 'a' : 'button';

      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-button--base', !(positive || negative || brand || neutral)), _defineProperty(_getClassName, 'p-button--neutral', neutral), _defineProperty(_getClassName, 'p-button--positive', positive), _defineProperty(_getClassName, 'p-button--negative', negative), _defineProperty(_getClassName, 'p-button--brand', brand), _defineProperty(_getClassName, 'is-inline', inline), _defineProperty(_getClassName, 'is--disabled', disabled), _getClassName)) || undefined;

      return _react2.default.createElement(
        Tag,
        _extends({
          className: classNames,
          href: Tag === 'a' ? href : undefined,
          onClick: this.onClick,
          disabled: disabled
        }, otherProps),
        value || children
      );
    }
  }]);

  return Button;
}(_react2.default.Component);

Button.defaultProps = {
  brand: false,
  children: null,
  className: null,
  disabled: false,
  href: null,
  inline: false,
  negative: false,
  neutral: false,
  onClick: function onClick() {
    return null;
  },
  positive: false,
  value: null
};

Button.propTypes = {
  brand: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  href: _propTypes2.default.string,
  inline: _propTypes2.default.bool,
  negative: _propTypes2.default.bool,
  neutral: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  positive: _propTypes2.default.bool,
  value: _propTypes2.default.string
};

Button.displayName = 'Button';

exports.default = Button;