'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = function (_React$Component) {
  _inherits(Card, _React$Component);

  function Card() {
    _classCallCheck(this, Card);

    var _this = _possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this));

    _this.getClassString = _this.getClassString.bind(_this);
    _this.renderHeader = _this.renderHeader.bind(_this);
    return _this;
  }

  _createClass(Card, [{
    key: 'getClassString',
    value: function getClassString() {
      var classString = 'p-card';

      if (this.props.highlighted) classString = classString + ' p-card--highlighted';
      if (this.props.overlay) classString = classString + ' p-card--overlay';

      return classString;
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var _props = this.props,
          header = _props.header,
          image = _props.image;


      return _react2.default.createElement(
        'header',
        { className: 'p-card__header' },
        image ? _react2.default.createElement('img', { src: image.src, alt: image.alt }) : _react2.default.createElement(
          'h1',
          null,
          header
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: this.getClassString() },
        (this.props.header || this.props.image) && this.renderHeader(),
        this.props.title && _react2.default.createElement(
          'h3',
          { className: 'p-card__title' },
          this.props.title
        ),
        this.props.children
      );
    }
  }]);

  return Card;
}(_react2.default.Component);

Card.defaultProps = {
  header: null,
  highlighted: false,
  image: null,
  overlay: false,
  title: null
};

Card.propTypes = {
  children: _propTypes2.default.node.isRequired,
  header: _propTypes2.default.string,
  highlighted: _propTypes2.default.bool,
  image: _propTypes2.default.shape({
    src: _propTypes2.default.string,
    alt: _propTypes2.default.string
  }),
  overlay: _propTypes2.default.bool,
  title: _propTypes2.default.string
};

Card.displayName = 'Card';

exports.default = Card;