'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _dedentJs = require('dedent-js');

var _dedentJs2 = _interopRequireDefault(_dedentJs);

var _pretty = require('pretty');

var _pretty2 = _interopRequireDefault(_pretty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CodeBlock = function CodeBlock(props) {
  var numbered = props.numbered;

  var code = props.children;

  if (typeof code === 'string') {
    code = (0, _dedentJs2.default)(code);
  } else {
    code = (0, _pretty2.default)(_server2.default.renderToStaticMarkup(code), { ocd: true });
  }

  if (numbered) {
    var codeArray = code.split(/\r?\n/);
    code = codeArray.map(function (line, i) {
      return _react2.default.createElement(
        'span',
        { key: line, className: 'code-line' },
        codeArray[i]
      );
    });
  }

  return _react2.default.createElement(
    'pre',
    { className: numbered ? 'p-code-numbered' : null },
    _react2.default.createElement(
      'code',
      null,
      code
    )
  );
};

CodeBlock.defaultProps = {
  children: '',
  numbered: false
};

CodeBlock.propTypes = {
  children: _propTypes2.default.node,
  numbered: _propTypes2.default.bool
};

CodeBlock.displayName = 'CodeBlock';

exports.default = CodeBlock;