'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _ContextualMenuDropdown = require('./ContextualMenuDropdown');

var _ContextualMenuDropdown2 = _interopRequireDefault(_ContextualMenuDropdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ContextualMenu = function (_React$Component) {
  _inherits(ContextualMenu, _React$Component);

  function ContextualMenu() {
    _classCallCheck(this, ContextualMenu);

    var _this = _possibleConstructorReturn(this, (ContextualMenu.__proto__ || Object.getPrototypeOf(ContextualMenu)).call(this));

    _this.toggleOpen = _this.toggleOpen.bind(_this);
    _this.state = { open: false };
    return _this;
  }

  _createClass(ContextualMenu, [{
    key: 'toggleOpen',
    value: function toggleOpen() {
      this.setState({ open: !this.state.open });
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName,
          _this2 = this;

      var _props = this.props,
          className = _props.className,
          children = _props.children,
          id = _props.id,
          position = _props.position,
          otherProps = _objectWithoutProperties(_props, ['className', 'children', 'id', 'position']);

      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-contextual-menu', true), _defineProperty(_getClassName, 'p-contextual-menu--' + position, position), _getClassName)) || undefined;

      var toggle = _react2.default.Children.map(children, function (child) {
        if (child.type !== _ContextualMenuDropdown2.default) {
          return _react2.default.cloneElement(child, {
            className: 'p-contextual-menu__toggle',
            'aria-controls': id,
            'aria-expanded': _this2.state.open,
            'aria-haspopup': 'true',
            role: 'link',
            onClick: _this2.toggleOpen,
            tabIndex: 0
          });
        } else if (child.type === _ContextualMenuDropdown2.default) {
          return _react2.default.cloneElement(child, {
            id: id,
            'aria-hidden': !_this2.state.open
          });
        }
        return child;
      });

      return _react2.default.createElement(
        'span',
        _extends({
          className: classNames
        }, otherProps),
        toggle
      );
    }
  }]);

  return ContextualMenu;
}(_react2.default.Component);

ContextualMenu.defaultProps = {
  children: null,
  className: null,
  position: null
};

ContextualMenu.propTypes = {
  children: function children(props, propName, componentName) {
    var prop = props[propName];
    var error = null;
    var count = 0;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type === _ContextualMenuDropdown2.default) {
        count += 1;
      }
    });

    if (count !== 1) {
      error = new Error(componentName + ' should have exactly one "ContextualMenuDropdown" child.');
    }

    return error;
  },
  className: _propTypes2.default.string,
  id: _propTypes2.default.string.isRequired,
  position: _propTypes2.default.oneOf(['left', 'center'])
};

ContextualMenu.displayName = 'ContextualMenu';

exports.default = ContextualMenu;