'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName3 = require('../../utils/getClassName');

var _getClassName4 = _interopRequireDefault(_getClassName3);

var _ContextualMenuGroup = require('./ContextualMenuGroup');

var _ContextualMenuGroup2 = _interopRequireDefault(_ContextualMenuGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ContextualMenuDropdown = function ContextualMenuDropdown(props) {
  var _getClassName;

  var children = props.children,
      className = props.className,
      otherProps = _objectWithoutProperties(props, ['children', 'className']);

  var classNames = (0, _getClassName4.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-contextual-menu__dropdown', true), _getClassName)) || undefined;

  var dropdownItems = _react2.default.Children.map(children, function (child) {
    if (child.type !== _ContextualMenuGroup2.default) {
      var _getClassName2;

      var childClasses = (0, _getClassName4.default)((_getClassName2 = {}, _defineProperty(_getClassName2, child.props.className, child.props.className), _defineProperty(_getClassName2, 'p-contextual-menu__link', true), _getClassName2));
      return _react2.default.cloneElement(child, {
        className: childClasses
      });
    }
    return child;
  });

  return _react2.default.createElement(
    'span',
    _extends({ className: classNames }, otherProps),
    dropdownItems
  );
};

ContextualMenuDropdown.defaultProps = {
  children: null,
  className: null
};

ContextualMenuDropdown.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string
};

ContextualMenuDropdown.displayName = 'ContextualMenuDropdown';

exports.default = ContextualMenuDropdown;