'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Form = function Form(props) {
  var _getClassName;

  var children = props.children,
      className = props.className,
      inline = props.inline,
      stacked = props.stacked,
      otherProps = _objectWithoutProperties(props, ['children', 'className', 'inline', 'stacked']);

  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-form', true), _defineProperty(_getClassName, 'p-form--inline', inline && !stacked), _defineProperty(_getClassName, 'p-form--stacked', stacked && !inline), _getClassName)) || undefined;

  return _react2.default.createElement(
    'form',
    _extends({ className: classNames }, otherProps),
    children
  );
};

Form.defaultProps = {
  children: null,
  className: undefined,
  inline: false,
  stacked: false
};

Form.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  inline: _propTypes2.default.bool,
  stacked: _propTypes2.default.bool
};

Form.displayName = 'Form';

exports.default = Form;