'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _FormHelpText = require('./FormHelpText');

var _FormHelpText2 = _interopRequireDefault(_FormHelpText);

var _Input = require('../Input/Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FormControl = function FormControl(props) {
  var _getClassName;

  var children = props.children,
      className = props.className,
      help = props.help,
      validation = props.validation;


  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-form__control', true), _defineProperty(_getClassName, 'p-form-validation', validation.status), _defineProperty(_getClassName, 'is-' + validation.status, validation && validation.status), _getClassName)) || undefined;

  var formControlItems = _react2.default.Children.map(children, function (child) {
    if (validation.status && child.type === _Input2.default) {
      return _react2.default.cloneElement(child, { hasValidation: true });
    }
    return child;
  });

  return _react2.default.createElement(
    'div',
    { className: classNames },
    formControlItems,
    validation.status && _react2.default.createElement(
      'p',
      { className: 'p-form-validation__message' },
      validation.tag && _react2.default.createElement(
        'strong',
        null,
        validation.tag
      ),
      validation.message
    ),
    help && _react2.default.createElement(
      _FormHelpText2.default,
      null,
      help
    )
  );
};

FormControl.defaultProps = {
  children: null,
  className: undefined,
  help: null,
  validation: {
    tag: null,
    status: null,
    message: null
  }
};

FormControl.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  help: _propTypes2.default.node,
  validation: _propTypes2.default.shape({
    tag: _propTypes2.default.string,
    status: _propTypes2.default.oneOf([null, 'caution', 'success', 'error']),
    message: _propTypes2.default.node
  })
};

FormControl.displayName = 'FormControl';

exports.default = FormControl;