'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Image = function Image(props) {
  var classArray = [];

  if (props.bordered) {
    classArray = [].concat(_toConsumableArray(classArray), ['p-image--bordered']);
  }
  if (props.shadowed) {
    classArray = [].concat(_toConsumableArray(classArray), ['p-image--shadowed']);
  }

  var classString = classArray.join(' ');

  return _react2.default.createElement('img', {
    style: props.style,
    className: classString,
    src: props.src,
    alt: props.alt
  });
};

Image.defaultProps = {
  alt: '',
  bordered: false,
  shadowed: false,
  style: null
};

Image.propTypes = {
  src: _propTypes2.default.string.isRequired,
  alt: _propTypes2.default.string,
  bordered: _propTypes2.default.bool,
  shadowed: _propTypes2.default.bool,
  style: _propTypes2.default.object
};

Image.displayName = 'Image';

exports.default = Image;