'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function inputTag(type) {
  if (type === 'select') {
    return 'select';
  } else if (type === 'textarea') {
    return 'textarea';
  }
  return 'input';
}

var Input = function Input(props) {
  var _getClassName;

  var className = props.className,
      hasValidation = props.hasValidation,
      type = props.type,
      otherProps = _objectWithoutProperties(props, ['className', 'hasValidation', 'type']);

  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-form-validation__input', hasValidation), _getClassName)) || undefined;

  var Tag = inputTag(type);

  return _react2.default.createElement(Tag, _extends({
    className: classNames,
    type: type
  }, otherProps));
};

Input.defaultProps = {
  className: undefined,
  type: 'text',
  hasValidation: false
};

Input.propTypes = {
  className: _propTypes2.default.string,
  id: _propTypes2.default.string.isRequired,
  type: _propTypes2.default.oneOf(['text', 'password', 'file', 'checkbox', 'radio', 'select', 'textarea', 'date', 'hidden', 'month', 'time', 'week', 'color', 'number', 'email', 'url', 'tel']),
  hasValidation: _propTypes2.default.bool
};

Input.displayName = 'Input';

exports.default = Input;