'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Label = function Label(props) {
  var _getClassName;

  var children = props.children,
      htmlFor = props.htmlFor,
      className = props.className,
      otherProps = _objectWithoutProperties(props, ['children', 'htmlFor', 'className']);

  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-form__label', true), _getClassName)) || undefined;

  return _react2.default.createElement(
    'label',
    _extends({ className: classNames, htmlFor: htmlFor }, otherProps),
    children
  ) // eslint-disable-line
  ;
};

Label.defaultProps = {
  children: null,
  className: undefined
};

Label.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  htmlFor: _propTypes2.default.string.isRequired
};

Label.displayName = 'Label';

exports.default = Label;