'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Link = function (_React$Component) {
  _inherits(Link, _React$Component);

  function Link() {
    _classCallCheck(this, Link);

    var _this = _possibleConstructorReturn(this, (Link.__proto__ || Object.getPrototypeOf(Link)).call(this));

    _this.onClick = _this.onClick.bind(_this);
    return _this;
  }

  _createClass(Link, [{
    key: 'onClick',
    value: function onClick(event) {
      var onClick = this.props.onClick;


      if (onClick) {
        event.preventDefault();
        onClick(event);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          soft = _props.soft,
          strong = _props.strong,
          inverted = _props.inverted,
          external = _props.external,
          top = _props.top,
          href = _props.href;


      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-link', true), _defineProperty(_getClassName, 'p-link--soft', soft), _defineProperty(_getClassName, 'p-link--strong', strong), _defineProperty(_getClassName, 'p-link--inverted', inverted), _defineProperty(_getClassName, 'p-link--external', external), _defineProperty(_getClassName, 'p-top__link', top), _getClassName));

      if (top) {
        return _react2.default.createElement(
          'div',
          { className: 'p-top' },
          _react2.default.createElement(
            'a',
            { href: href, className: classNames, onClick: this.onClick },
            children
          )
        );
      }

      return _react2.default.createElement(
        'a',
        { href: href, className: classNames, onClick: this.onClick },
        children
      );
    }
  }]);

  return Link;
}(_react2.default.Component);

Link.defaultProps = {
  className: '',
  soft: false,
  strong: false,
  inverted: false,
  external: false,
  top: false,
  onClick: null
};

Link.propTypes = {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  href: _propTypes2.default.string.isRequired,
  soft: _propTypes2.default.bool,
  strong: _propTypes2.default.bool,
  inverted: _propTypes2.default.bool,
  external: _propTypes2.default.bool,
  top: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

Link.displayName = 'Link';

exports.default = Link;