'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListItem = function ListItem(props) {
  var listItemType = void 0;
  switch (props.modifier) {
    case 'inline':
    case 'middot':
      listItemType = 'p-inline-list__item';
      break;
    default:
      listItemType = 'p-list__item';
  }

  return _react2.default.createElement(
    'li',
    { className: '' + listItemType + (props.ticked ? ' is-ticked' : '') },
    props.children
  );
};

ListItem.defaultProps = {
  ticked: false,
  modifier: ''
};

ListItem.propTypes = {
  children: _propTypes2.default.node.isRequired,
  ticked: _propTypes2.default.bool,
  modifier: _propTypes2.default.string
};

ListItem.displayName = 'ListItem';

exports.default = ListItem;