'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListTree = function ListTree(props) {
  var listTreeChildren = _react2.default.Children.map(props.children, function (child, index) {
    return _react2.default.cloneElement(child, { index: '' + index });
  });

  return _react2.default.createElement(
    'ul',
    { className: 'p-list-tree', 'aria-multiselectable': 'true', role: 'tablist' },
    listTreeChildren
  );
};

ListTree.propTypes = {
  children: _propTypes2.default.node.isRequired
};

ListTree.displayName = 'ListTree';

exports.default = ListTree;