'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListTreeGroup = function (_React$Component) {
  _inherits(ListTreeGroup, _React$Component);

  function ListTreeGroup() {
    _classCallCheck(this, ListTreeGroup);

    var _this = _possibleConstructorReturn(this, (ListTreeGroup.__proto__ || Object.getPrototypeOf(ListTreeGroup)).call(this));

    _this.onClick = _this.onClick.bind(_this);
    _this.state = {
      open: false
    };
    return _this;
  }

  _createClass(ListTreeGroup, [{
    key: 'onClick',
    value: function onClick() {
      var open = this.state.open;

      this.setState({ open: !open });
    }
  }, {
    key: 'render',
    value: function render() {
      var index = this.props.index;

      var listTreeGroupChildren = _react2.default.Children.map(this.props.children, function (child, key) {
        return _react2.default.cloneElement(child, { index: index + '-' + key });
      });

      return _react2.default.createElement(
        'li',
        { className: 'p-list-tree__item p-list-tree__item--group' },
        _react2.default.createElement(
          'button',
          {
            className: 'p-list-tree__toggle',
            id: 'listtree-' + index + '-btn',
            role: 'tab',
            'aria-controls': 'listtree-' + index,
            'aria-expanded': this.state.open,
            onClick: this.onClick
          },
          this.props.name
        ),
        _react2.default.createElement(
          'ul',
          {
            className: 'p-list-tree',
            id: 'listtree-' + index,
            role: 'tabpanel',
            'aria-hidden': !this.state.open,
            'aria-labelledby': 'listtree-' + index + '-btn'
          },
          listTreeGroupChildren
        )
      );
    }
  }]);

  return ListTreeGroup;
}(_react2.default.Component);

ListTreeGroup.defaultProps = {
  index: '0'
};

ListTreeGroup.propTypes = {
  children: _propTypes2.default.node.isRequired,
  index: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired
};

ListTreeGroup.displayName = 'ListTreeGroup';

exports.default = ListTreeGroup;