'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MatrixItem = require('./MatrixItem');

var _MatrixItem2 = _interopRequireDefault(_MatrixItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Matrix = function (_React$Component) {
  _inherits(Matrix, _React$Component);

  function Matrix() {
    _classCallCheck(this, Matrix);

    var _this = _possibleConstructorReturn(this, (Matrix.__proto__ || Object.getPrototypeOf(Matrix)).call(this));

    _this.generateExtras = _this.generateExtras.bind(_this);
    return _this;
  }

  _createClass(Matrix, [{
    key: 'generateExtras',
    value: function generateExtras() {
      var children = this.props.children;

      var emptyItemCount = 2 * _react2.default.Children.count(children) % 3;
      var extraMatrixItems = [];

      for (var i = 0; i < emptyItemCount; i += 1) {
        extraMatrixItems.push(_react2.default.createElement(_MatrixItem2.default, { key: i, className: 'u-hide--small' }));
      }

      return extraMatrixItems;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;

      // Generate extra MatrixItems to fill empty space in a row

      var extraMatrixItems = this.generateExtras();

      return _react2.default.createElement(
        'ul',
        { className: 'p-matrix u-clearfix' },
        children,
        extraMatrixItems.length > 0 && extraMatrixItems
      );
    }
  }]);

  return Matrix;
}(_react2.default.Component);

Matrix.defaultProps = {
  children: null
};

Matrix.propTypes = {
  children: function children(props, propName, componentName) {
    var prop = props[propName];
    var error = null;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type !== _MatrixItem2.default) {
        error = new Error(componentName + ' children should be of type "MatrixItem".');
      }
    });

    return error;
  }
};

Matrix.displayName = 'Matrix';

exports.default = Matrix;