'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MatrixItem = function MatrixItem(props) {
  var _getClassName;

  var children = props.children,
      className = props.className,
      href = props.href,
      img = props.img,
      title = props.title;


  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-matrix__item', true), _getClassName)) || undefined;

  return _react2.default.createElement(
    'li',
    { className: classNames },
    img && _react2.default.createElement('img', { className: 'p-matrix__img', src: img.src, alt: img.alt }),
    _react2.default.createElement(
      'div',
      { className: 'p-matrix__content' },
      title && _react2.default.createElement(
        'h3',
        { className: 'p-matrix__title' },
        href ? _react2.default.createElement(
          'a',
          { className: 'p-matrix__link', href: href },
          title
        ) : title
      ),
      _react2.default.createElement(
        'div',
        { className: 'p-matrix__desc' },
        children
      )
    )
  );
};

MatrixItem.defaultProps = {
  children: null,
  className: undefined,
  href: '',
  img: null,
  title: ''
};

MatrixItem.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  img: _propTypes2.default.shape({
    src: _propTypes2.default.string,
    alt: _propTypes2.default.string
  }),
  href: _propTypes2.default.string,
  title: _propTypes2.default.string
};

MatrixItem.displayName = 'MatrixItem';

exports.default = MatrixItem;