'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MediaObject = function (_React$Component) {
  _inherits(MediaObject, _React$Component);

  function MediaObject() {
    _classCallCheck(this, MediaObject);

    var _this = _possibleConstructorReturn(this, (MediaObject.__proto__ || Object.getPrototypeOf(MediaObject)).call(this));

    _this.generateMetadata = _this.generateMetadata.bind(_this);
    return _this;
  }

  _createClass(MediaObject, [{
    key: 'generateMetadata',
    value: function generateMetadata() {
      var metadata = this.props.metadata;


      var metadataItems = metadata.map(function (item, index) {
        var description = item.description,
            type = item.type;

        var key = '' + type + index;
        var metadataClass = (0, _getClassName3.default)({
          'p-media-object__meta-list-item': !type,
          'p-media-object__meta-list-item--date': type === 'date',
          'p-media-object__meta-list-item--location': type === 'location',
          'p-media-object__meta-list-item--venue': type === 'venue'
        }) || undefined;

        return _react2.default.createElement(
          'li',
          { key: key, className: metadataClass },
          description
        );
      });

      return _react2.default.createElement(
        'ul',
        { className: 'p-media-object__meta-list' },
        metadataItems
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          href = _props.href,
          img = _props.img,
          large = _props.large,
          metadata = _props.metadata,
          round = _props.round,
          title = _props.title;


      var containerClass = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-media-object', !large), _defineProperty(_getClassName, 'p-media-object--large', large), _getClassName)) || undefined;

      var imgClass = (0, _getClassName3.default)({
        'p-media-object__image': true,
        'is-round': round
      } || undefined);

      return _react2.default.createElement(
        'div',
        { className: containerClass },
        img && _react2.default.createElement('img', { className: imgClass, src: img.src, alt: img.alt }),
        _react2.default.createElement(
          'div',
          { className: 'p-media-object__details' },
          title && _react2.default.createElement(
            'h3',
            { className: 'p-media-object__title' },
            href ? _react2.default.createElement(
              'a',
              { href: href },
              title
            ) : title
          ),
          children && _react2.default.createElement(
            'div',
            { className: 'p-media-object__content' },
            children
          ),
          metadata && this.generateMetadata()
        )
      );
    }
  }]);

  return MediaObject;
}(_react2.default.Component);

MediaObject.defaultProps = {
  children: undefined,
  className: undefined,
  href: undefined,
  img: undefined,
  large: false,
  metadata: undefined,
  round: false,
  title: undefined
};

MediaObject.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  href: _propTypes2.default.string,
  img: _propTypes2.default.shape({
    alt: _propTypes2.default.string,
    src: _propTypes2.default.string
  }),
  large: _propTypes2.default.bool,
  metadata: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    description: _propTypes2.default.string,
    type: _propTypes2.default.string
  })),
  round: _propTypes2.default.bool,
  title: _propTypes2.default.string
};

MediaObject.displayName = 'MediaObject';

exports.default = MediaObject;