'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Modal = function Modal(props) {
  var children = props.children,
      onClick = props.onClick,
      show = props.show,
      title = props.title;


  return _react2.default.createElement(
    'div',
    {
      className: 'p-modal',
      style: { display: show ? 'flex' : 'none' }
    },
    _react2.default.createElement(
      'div',
      {
        className: 'p-modal__dialog',
        role: 'dialog',
        'aria-labelledby': 'modal-title',
        'aria-describedby': 'modal-description'
      },
      _react2.default.createElement(
        'header',
        { className: 'p-modal__header' },
        _react2.default.createElement(
          'h2',
          { className: 'p-modal__title' },
          title
        ),
        _react2.default.createElement(
          'button',
          {
            className: 'p-modal__close',
            'aria-label': 'Close active modal',
            onClick: onClick
          },
          'Close'
        )
      ),
      children
    )
  );
};

Modal.defaultProps = {
  onClick: function onClick() {
    return 1;
  },
  show: false,
  title: null
};

Modal.propTypes = {
  children: _propTypes2.default.node.isRequired,
  onClick: _propTypes2.default.func,
  show: _propTypes2.default.bool,
  title: _propTypes2.default.string
};

Modal.displayName = 'Modal';

exports.default = Modal;