'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _NavigationBanner = require('./NavigationBanner');

var _NavigationBanner2 = _interopRequireDefault(_NavigationBanner);

var _NavigationLink = require('./NavigationLink');

var _NavigationLink2 = _interopRequireDefault(_NavigationLink);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navigation = function (_React$Component) {
  _inherits(Navigation, _React$Component);

  function Navigation() {
    _classCallCheck(this, Navigation);

    return _possibleConstructorReturn(this, (Navigation.__proto__ || Object.getPrototypeOf(Navigation)).apply(this, arguments));
  }

  _createClass(Navigation, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;

      var links = [];
      var banner = void 0;

      _react2.default.Children.forEach(children, function (child) {
        if (child.type === _NavigationBanner2.default) {
          banner = child;
        } else if (child.type === _NavigationLink2.default) {
          links.push(child);
        }
      });

      return _react2.default.createElement(
        'header',
        { id: 'navigation', className: 'p-navigation' },
        banner,
        links.length > 0 && _react2.default.createElement(
          'nav',
          { className: 'p-navigation__nav' },
          _react2.default.createElement(
            'ul',
            { className: 'p-navigation__links', role: 'menu' },
            links
          )
        )
      );
    }
  }]);

  return Navigation;
}(_react2.default.Component);

Navigation.defaultProps = {
  children: null
};

Navigation.propTypes = {
  children: function children(props, propName, componentName) {
    var prop = props[propName];
    var error = null;
    var count = 0;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type === _NavigationBanner2.default) {
        count += 1;
      }
    });

    if (count !== 1) {
      error = new Error(componentName + ' should have exactly one child of type "NavigationBanner".');
    }

    return error;
  }
};

Navigation.displayName = 'Navigation';

exports.default = Navigation;