'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavigationBanner = function (_React$Component) {
  _inherits(NavigationBanner, _React$Component);

  function NavigationBanner() {
    _classCallCheck(this, NavigationBanner);

    return _possibleConstructorReturn(this, (NavigationBanner.__proto__ || Object.getPrototypeOf(NavigationBanner)).apply(this, arguments));
  }

  _createClass(NavigationBanner, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          href = _props.href,
          logo = _props.logo,
          menuText = _props.menuText,
          title = _props.title;


      var Tag = href ? 'a' : 'div';

      return _react2.default.createElement(
        'div',
        { className: 'p-navigation__banner' },
        _react2.default.createElement(
          'div',
          { className: 'p-navigation__logo' },
          _react2.default.createElement(
            Tag,
            { className: 'p-navigation__link', href: href },
            logo.src ? _react2.default.createElement('img', { className: 'p-navigation__image', src: logo.src, alt: logo.alt }) : _react2.default.createElement(
              'h3',
              { style: { margin: 0, alignSelf: 'center' } },
              title
            )
          )
        ),
        _react2.default.createElement(
          'a',
          { href: '#navigation', className: 'p-navigation__toggle--open', title: 'menu' },
          menuText.open
        ),
        _react2.default.createElement(
          'a',
          { href: '#navigation-closed', className: 'p-navigation__toggle--close', title: 'close menu' },
          menuText.close
        )
      );
    }
  }]);

  return NavigationBanner;
}(_react2.default.Component);

NavigationBanner.defaultProps = {
  href: null,
  logo: { src: null, alt: '' },
  menuText: { open: 'Menu', close: 'Close menu' },
  title: null
};

NavigationBanner.propTypes = {
  href: _propTypes2.default.string,
  logo: _propTypes2.default.shape({ src: _propTypes2.default.string, alt: _propTypes2.default.string }),
  menuText: _propTypes2.default.shape({ open: _propTypes2.default.string, close: _propTypes2.default.string }),
  title: _propTypes2.default.string
};

NavigationBanner.displayName = 'NavigationBanner';

exports.default = NavigationBanner;