'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName = require('../../utils/getClassName');

var _getClassName2 = _interopRequireDefault(_getClassName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NavigationLink = function NavigationLink(props) {
  var href = props.href,
      label = props.label,
      selected = props.selected;


  var className = (0, _getClassName2.default)({
    'p-navigation__link': true,
    'is-selected': selected
  });

  return _react2.default.createElement(
    'li',
    { className: className, role: 'menuitem' },
    _react2.default.createElement(
      'a',
      { href: href },
      label
    )
  );
};

NavigationLink.defaultProps = {
  selected: false
};

NavigationLink.propTypes = {
  label: _propTypes2.default.string.isRequired,
  href: _propTypes2.default.string.isRequired,
  selected: _propTypes2.default.bool
};

NavigationLink.displayName = 'NavigationLink';

exports.default = NavigationLink;