'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Notification = function (_React$Component) {
  _inherits(Notification, _React$Component);

  function Notification(props) {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    _this.state = {
      visible: props.visible
    };
    return _this;
  }

  _createClass(Notification, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.visible !== this.props.visible) {
        this.setState({ visible: nextProps.visible });
      }
    }
  }, {
    key: 'handleClick',
    value: function handleClick(event) {
      var onClick = this.props.onClick;
      var visible = this.state.visible;


      if (onClick) {
        onClick(event);
      } else {
        this.setState({ visible: !visible });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props = this.props,
          action = _props.action,
          children = _props.children,
          className = _props.className,
          dismissable = _props.dismissable,
          status = _props.status,
          caution = _props.caution,
          information = _props.information,
          negative = _props.negative,
          positive = _props.positive,
          onClick = _props.onClick;
      var visible = this.state.visible;

      // XXX Can remove when bug is fixed in Vanilla Sass
      // https://github.com/vanilla-framework/vanilla-framework/issues/1928

      var styleFix = {
        backgroundColor: 'transparent',
        backgroundSize: '1rem',
        border: '0',
        margin: '1.1875rem 1rem auto auto',
        padding: '.5rem'
      };

      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-notification--information', information), _defineProperty(_getClassName, 'p-notification--positive', positive), _defineProperty(_getClassName, 'p-notification--caution', caution), _defineProperty(_getClassName, 'p-notification--negative', negative), _getClassName)) || 'p-notification';

      return _react2.default.createElement(
        'div',
        { style: visible ? { display: 'flex' } : { display: 'none' }, className: classNames },
        _react2.default.createElement(
          'p',
          { className: 'p-notification__response' },
          status && _react2.default.createElement(
            'span',
            { className: 'p-notification__status' },
            status
          ),
          children,
          action && _react2.default.createElement(
            'a',
            { href: action.href, className: 'p-notification__action' },
            action.value
          )
        ),
        (dismissable || onClick) && _react2.default.createElement(
          'button',
          {
            style: styleFix,
            className: 'p-icon--close',
            'aria-label': 'Close notification',
            onClick: this.handleClick
          },
          'Close'
        )
      );
    }
  }]);

  return Notification;
}(_react2.default.Component);

Notification.defaultProps = {
  action: null,
  caution: false,
  className: undefined,
  dismissable: true,
  information: false,
  negative: false,
  onClick: undefined,
  positive: false,
  status: null,
  visible: true
};

Notification.propTypes = {
  action: _propTypes2.default.shape({
    value: _propTypes2.default.string,
    href: _propTypes2.default.string
  }),
  caution: _propTypes2.default.bool,
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  dismissable: _propTypes2.default.bool,
  information: _propTypes2.default.bool,
  negative: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  positive: _propTypes2.default.bool,
  status: _propTypes2.default.string,
  visible: _propTypes2.default.bool
};

Notification.displayName = 'Notification';

exports.default = Notification;