'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PaginationItem = function PaginationItem(props) {
  var href = props.href,
      label = props.label,
      next = props.next,
      previous = props.previous,
      title = props.title;


  var className = 'p-pagination__link';

  if (next) {
    className += '--next';
  } else if (previous) {
    className += '--previous';
  }

  return _react2.default.createElement(
    'a',
    { className: className, href: href },
    _react2.default.createElement(
      'span',
      { className: 'p-pagination__label' },
      label
    ),
    _react2.default.createElement(
      'span',
      { className: 'p-pagination__title' },
      title
    )
  );
};

PaginationItem.defaultProps = {
  href: null,
  label: '',
  next: false,
  previous: false,
  title: ''
};

PaginationItem.propTypes = {
  href: _propTypes2.default.string,
  label: _propTypes2.default.string,
  next: _propTypes2.default.bool,
  previous: _propTypes2.default.bool,
  title: _propTypes2.default.string
};

PaginationItem.displayName = 'PaginationItem';

exports.default = PaginationItem;