'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SideNavBanner = function (_React$Component) {
  _inherits(SideNavBanner, _React$Component);

  function SideNavBanner() {
    _classCallCheck(this, SideNavBanner);

    return _possibleConstructorReturn(this, (SideNavBanner.__proto__ || Object.getPrototypeOf(SideNavBanner)).apply(this, arguments));
  }

  _createClass(SideNavBanner, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          href = _props.href,
          logo = _props.logo,
          onClick = _props.onClick,
          open = _props.open,
          tagline = _props.tagline,
          title = _props.title;


      var Tag = href ? 'a' : 'div';

      return _react2.default.createElement(
        'header',
        { id: 'sidenav', role: 'banner' },
        _react2.default.createElement(
          'div',
          { className: 'p-navigation__banner' },
          _react2.default.createElement(
            'div',
            { className: 'row u-no-margin--left' },
            _react2.default.createElement(
              'div',
              { className: 'mobile-col-2' },
              _react2.default.createElement(
                'div',
                { className: 'p-navigation__logo' },
                _react2.default.createElement(
                  Tag,
                  { className: 'p-navigation__link', href: href },
                  logo.src ? _react2.default.createElement('img', { className: 'p-navigation__image', src: logo.src, alt: logo.alt }) : title
                )
              ),
              tagline && _react2.default.createElement(
                'span',
                { className: 'p-navigation__tagline' },
                tagline
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'sidebar__cta mobile-col-2 u-align--right' },
              _react2.default.createElement(
                'ul',
                { className: 'p-inline-list u-no-margin--top' },
                _react2.default.createElement(
                  'li',
                  { className: 'p-inline-list__item' },
                  _react2.default.createElement('i', {
                    className: 'p-icon--menu ' + (open ? 'u-hide' : ''),
                    onClick: onClick,
                    onKeyDown: function onKeyDown(key) {
                      return key === 'Enter' && onClick;
                    },
                    'aria-hidden': open ? 'true' : 'false',
                    role: 'button',
                    tabIndex: 0
                  }),
                  _react2.default.createElement('i', {
                    className: 'p-icon--close ' + (open ? '' : 'u-hide'),
                    onClick: onClick,
                    onKeyDown: function onKeyDown(key) {
                      return key === 'Enter' && onClick;
                    },
                    'aria-hidden': open ? 'false' : 'true',
                    role: 'button',
                    tabIndex: 0
                  })
                )
              )
            )
          )
        )
      );
    }
  }]);

  return SideNavBanner;
}(_react2.default.Component);

SideNavBanner.defaultProps = {
  href: null,
  logo: { src: null, alt: '' },
  onClick: function onClick() {
    return 1;
  },
  open: false,
  tagline: '',
  title: null
};

SideNavBanner.propTypes = {
  href: _propTypes2.default.string,
  logo: _propTypes2.default.shape({ src: _propTypes2.default.string, alt: _propTypes2.default.string }),
  onClick: _propTypes2.default.func,
  open: _propTypes2.default.bool,
  tagline: _propTypes2.default.string,
  title: _propTypes2.default.string
};

SideNavBanner.displayName = 'SideNavBanner';

exports.default = SideNavBanner;