'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName = require('../../utils/getClassName');

var _getClassName2 = _interopRequireDefault(_getClassName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SideNavLink = function SideNavLink(props) {
  var children = props.children,
      href = props.href,
      label = props.label,
      selected = props.selected;


  var className = (0, _getClassName2.default)({
    sidebar__link: true,
    'is-selected': selected
  });

  return _react2.default.createElement(
    'li',
    null,
    _react2.default.createElement(
      'a',
      { className: className, href: href },
      label,
      children
    )
  );
};

SideNavLink.defaultProps = {
  children: null,
  selected: false
};

SideNavLink.propTypes = {
  children: _propTypes2.default.node,
  label: _propTypes2.default.string.isRequired,
  href: _propTypes2.default.string.isRequired,
  selected: _propTypes2.default.bool
};

SideNavLink.displayName = 'SideNavLink';

exports.default = SideNavLink;