'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ensureValueInRange = require('../../utils/ensureValueInRange');

var _ensureValueInRange2 = _interopRequireDefault(_ensureValueInRange);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _SliderInput = require('./SliderInput');

var _SliderInput2 = _interopRequireDefault(_SliderInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Slider = function (_React$Component) {
  _inherits(Slider, _React$Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    _this.handleChange = _this.handleChange.bind(_this);

    var value = (0, _ensureValueInRange2.default)(props.value, props.max, props.min);
    _this.state = { value: value };
    return _this;
  }

  _createClass(Slider, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = nextProps.value,
          max = nextProps.max,
          min = nextProps.min;

      var newValue = (0, _ensureValueInRange2.default)(value, max, min);

      this.setState({ value: newValue });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      var _props = this.props,
          max = _props.max,
          min = _props.min;

      var targetValue = Number(e.target.value);
      var newValue = (0, _ensureValueInRange2.default)(targetValue, max, min);

      this.setState({ value: newValue });
    }

    // Fix for Chrome and Safari as they don't support CSS slider progress

  }, {
    key: 'handleStyle',
    value: function handleStyle() {
      var value = this.state.value;
      var _props2 = this.props,
          max = _props2.max,
          min = _props2.min;


      var ratio = (value - min) / (max - min);
      return { backgroundImage: '-webkit-gradient(linear, left top, right top, color-stop(' + ratio + ', #335280), color-stop(' + ratio + ', #fff))' };
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props3 = this.props,
          className = _props3.className,
          disabled = _props3.disabled,
          max = _props3.max,
          min = _props3.min,
          showValue = _props3.showValue,
          step = _props3.step;
      var value = this.state.value;


      var style = void 0;
      if (/Chrome/i.test(navigator.userAgent) || /Safari/i.test(navigator.userAgent)) {
        style = this.handleStyle();
      }

      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-slider', true), _getClassName)) || undefined;

      return _react2.default.createElement(
        'div',
        { className: 'p-slider__wrapper' },
        _react2.default.createElement('input', {
          className: classNames,
          disabled: disabled,
          max: max,
          min: min,
          step: step,
          style: style,
          type: 'range',
          value: value,
          onChange: this.handleChange
        }),
        showValue && _react2.default.createElement(_SliderInput2.default, {
          disabled: disabled,
          value: value,
          onChange: this.handleChange
        })
      );
    }
  }]);

  return Slider;
}(_react2.default.Component);

Slider.defaultProps = {
  className: undefined,
  disabled: false,
  max: 100,
  min: 0,
  showValue: false,
  step: 1,
  value: undefined
};

Slider.propTypes = {
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  max: _propTypes2.default.number,
  min: _propTypes2.default.number,
  showValue: _propTypes2.default.bool,
  step: _propTypes2.default.number,
  value: _propTypes2.default.number
};

Slider.displayName = 'Slider';

exports.default = Slider;