'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SteppedList = function SteppedList(props) {
  if (!props.children) {
    return null;
  }

  var steppedListItems = _react2.default.Children.map(props.children, function (child, index) {
    return _react2.default.cloneElement(child, {
      index: index,
      detailed: props.detailed
    });
  });

  return _react2.default.createElement(
    'ol',
    { className: props.detailed ? 'p-stepped-list--detailed' : 'p-list-step' },
    steppedListItems
  );
};

SteppedList.defaultProps = {
  children: '',
  detailed: false
};

SteppedList.propTypes = {
  children: _propTypes2.default.node,
  detailed: _propTypes2.default.bool
};

SteppedList.displayName = 'SteppedList';

exports.default = SteppedList;