'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SteppedListItem = function SteppedListItem(props) {
  return _react2.default.createElement(
    'li',
    { className: 'p-list-step__item' },
    _react2.default.createElement(
      'h3',
      { className: 'p-list-step__title' },
      _react2.default.createElement(
        'span',
        { className: 'p-list-step__bullet' },
        props.bullet ? props.bullet : props.index + 1
      ),
      props.title
    ),
    _react2.default.createElement(
      'p',
      { className: props.detailed ? 'p-list-step__content' : null },
      props.children
    )
  );
};

SteppedListItem.defaultProps = {
  bullet: '',
  children: '',
  detailed: false,
  index: 0
};

SteppedListItem.propTypes = {
  bullet: _propTypes2.default.string,
  children: _propTypes2.default.node,
  detailed: _propTypes2.default.bool,
  index: _propTypes2.default.number,
  title: _propTypes2.default.string.isRequired
};

SteppedListItem.displayName = 'SteppedListItem';

exports.default = SteppedListItem;