'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Strip = function Strip(props) {
  var classArray = [];
  var style = Object.assign({}, props.style);
  var colour = props.colour,
      image = props.image,
      bordered = props.bordered,
      padding = props.padding,
      children = props.children;


  if (colour) {
    classArray = [].concat(_toConsumableArray(classArray), ['p-strip--' + props.colour]);
  }

  if (image.src) {
    var imageColour = 'is-' + image.colour;
    classArray = [].concat(_toConsumableArray(classArray), ['p-strip--image', imageColour]);
    style = Object.assign(style, { backgroundImage: 'url(' + image.src + ')' });
  }

  if (bordered) {
    classArray = [].concat(_toConsumableArray(classArray), ['is-bordered']);
  }

  if (padding) {
    classArray = [].concat(_toConsumableArray(classArray), ['is-' + padding]);
  }

  var classString = classArray.join(' ');

  return _react2.default.createElement(
    'section',
    {
      className: classString,
      style: style
    },
    children
  );
};

Strip.defaultProps = {
  colour: 'light',
  bordered: false,
  padding: null,
  image: {
    src: '',
    colour: 'dark'
  },
  style: {}
};

Strip.propTypes = {
  children: _propTypes2.default.node.isRequired,
  colour: _propTypes2.default.oneOf(['light', 'dark', 'accent']),
  image: _propTypes2.default.shape({
    src: _propTypes2.default.string,
    colour: _propTypes2.default.oneOf(['light', 'dark'])
  }),
  bordered: _propTypes2.default.bool,
  padding: _propTypes2.default.oneOf(['shallow', 'deep']),
  style: _propTypes2.default.object
};

Strip.displayName = 'Strip';

exports.default = Strip;