'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StripColumn = function StripColumn(props) {
  if (props.size < 1 || props.size > 12) {
    return new Error('StripColumn component must have size between 1 and 12');
  }
  return _react2.default.createElement(
    'div',
    { className: 'col-' + props.size, style: props.style },
    props.children
  );
};

StripColumn.defaultProps = {
  style: {},
  size: 12
};

StripColumn.propTypes = {
  children: _propTypes2.default.node.isRequired,
  size: _propTypes2.default.number,
  style: _propTypes2.default.object
};

StripColumn.displayName = 'StripColumn';

exports.default = StripColumn;