'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Switch = function Switch(props) {
  var checked = props.checked,
      id = props.id,
      label = props.label;


  return _react2.default.createElement(
    'label',
    { htmlFor: id },
    label,
    _react2.default.createElement('input', {
      id: id,
      type: 'checkbox',
      className: 'p-switch',
      value: checked ? 'on' : 'off',
      checked: checked
    }),
    _react2.default.createElement('div', { className: 'p-switch__slider' })
  );
};

Switch.defaultProps = {
  checked: false,
  label: undefined
};

Switch.propTypes = {
  checked: _propTypes2.default.bool,
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string
};

Switch.displayName = 'Switch';

exports.default = Switch;