'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _naturalCompareLite = require('natural-compare-lite');

var _naturalCompareLite2 = _interopRequireDefault(_naturalCompareLite);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _TableCell = require('./TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _Button = require('../Button/Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.generateData = _this.generateData.bind(_this);
    _this.generateHeader = _this.generateHeader.bind(_this);
    _this.generateRows = _this.generateRows.bind(_this);
    _this.generateCells = _this.generateCells.bind(_this);
    _this.generateExpandedCell = _this.generateExpandedCell.bind(_this);
    _this.getNewSortCondition = _this.getNewSortCondition.bind(_this);
    _this.handleExpand = _this.handleExpand.bind(_this);
    _this.sortData = _this.sortData.bind(_this);

    _this.state = {
      columns: props.columns ? [].concat(_toConsumableArray(props.columns)) : null,
      data: props.data ? [].concat(_toConsumableArray(props.data)) : null,
      expandedRows: [],
      originalData: props.data ? [].concat(_toConsumableArray(props.data)) : null,
      sortCondition: props.sortCondition
    };
    return _this;
  }

  _createClass(Table, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _state = this.state,
          columns = _state.columns,
          data = _state.data,
          sortCondition = _state.sortCondition;

      // If Table is static, convert data to object

      if (!data || !columns) {
        this.generateData();
      }

      // Pre-sort Table if sortCondition prop is non-zero
      if (Object.keys(sortCondition).length === 1) {
        var columnKey = Object.keys(sortCondition)[0];
        this.sortData(columnKey);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.data !== this.props.data) {
        this.setState({ data: [].concat(_toConsumableArray(nextProps.data)), columns: [].concat(_toConsumableArray(nextProps.columns)) });
      }
    }
  }, {
    key: 'getNewSortCondition',
    value: function getNewSortCondition(columnKey) {
      var _this2 = this;

      var sortCondition = this.state.sortCondition;

      var newSortCondition = {};
      var options = ['ascending', 'descending', 'none'];

      // Move to next option in options array
      newSortCondition[columnKey] = options[(options.indexOf(sortCondition[columnKey]) + 1) % options.length];

      this.setState({ sortCondition: newSortCondition }, function () {
        _this2.sortData(columnKey);
      });
    }
  }, {
    key: 'sortData',
    value: function sortData(columnKey) {
      var _state2 = this.state,
          data = _state2.data,
          sortCondition = _state2.sortCondition;


      if (sortCondition[columnKey] === 'none') {
        var unsortedData = this.state.originalData;
        this.setState({ data: [].concat(_toConsumableArray(unsortedData)) });
      } else {
        var sortedData = data.sort(function (a, b) {
          var x = a[columnKey];
          var y = b[columnKey];
          return sortCondition[columnKey] === 'ascending' ? (0, _naturalCompareLite2.default)(x, y) : (0, _naturalCompareLite2.default)(y, x);
        });

        this.setState({ data: sortedData });
      }
    }
  }, {
    key: 'handleExpand',
    value: function handleExpand(rowId) {
      var _props = this.props,
          accordion = _props.accordion,
          expandable = _props.expandable;


      if (expandable) {
        var expandedRows = this.state.expandedRows;

        var isExpanded = expandedRows.includes(rowId);
        var newExpandedRows = void 0;

        if (isExpanded) {
          newExpandedRows = expandedRows.filter(function (id) {
            return id !== rowId;
          });
        } else if (accordion) {
          newExpandedRows = [rowId];
        } else {
          newExpandedRows = expandedRows.concat(rowId);
        }

        this.setState({ expandedRows: newExpandedRows });
      }
    }
  }, {
    key: 'generateData',
    value: function generateData() {
      var children = this.props.children;

      var columns = [];
      var data = [];

      children.forEach(function (row, rowIndex) {
        if (row.props.tableHeader) {
          row.props.children.forEach(function (cell, cellIndex) {
            var value = '';
            if (typeof cell.props.children === 'string') value = cell.props.children;
            columns.push({
              key: 'column' + cellIndex,
              label: value,
              align: cell.props.align,
              header: cell.props.columnHeader
            });
          });
        } else {
          var index = rowIndex - 1;
          data[index] = {};
          data[index].id = rowIndex;
          row.props.children.forEach(function (cell, cellIndex) {
            var value = '';
            if (typeof cell.props.children === 'string') {
              value = cell.props.children;
            }
            if (cell.props.expandedCell) {
              data[index].expandedCell = cell.props.children;
            } else {
              data[index]['column' + cellIndex] = value;
            }
          });
        }
      });

      this.setState({
        columns: columns,
        data: [].concat(data),
        originalData: data
      });
    }
  }, {
    key: 'generateHeader',
    value: function generateHeader() {
      var _this3 = this;

      var _state3 = this.state,
          columns = _state3.columns,
          sortCondition = _state3.sortCondition;
      var _props2 = this.props,
          expandable = _props2.expandable,
          sortable = _props2.sortable;


      var columnHeaders = columns.map(function (column) {
        return _react2.default.createElement(
          _TableCell2.default,
          {
            columnHeader: true,
            key: column.key,
            ariaSort: sortCondition[column.key],
            align: column.align,
            onClick: sortable ? function () {
              return _this3.getNewSortCondition(column.key);
            } : null
          },
          column.label
        );
      });

      if (expandable) {
        columnHeaders = columnHeaders.concat([_react2.default.createElement(_TableCell2.default, {
          columnHeader: true,
          key: 'expandCol',
          align: 'right',
          style: { flexBasis: '4rem', flexGrow: '0' },
          ariaSort: null
        }), _react2.default.createElement(_TableCell2.default, { className: 'u-hide', key: 'nullHeader' })]);
      }

      var header = _react2.default.createElement(
        'thead',
        null,
        _react2.default.createElement(
          _TableRow2.default,
          { key: 'header-row' },
          columnHeaders
        )
      );

      return header;
    }
  }, {
    key: 'generateRows',
    value: function generateRows() {
      var _this4 = this;

      var data = this.state.data;
      var expandable = this.props.expandable;

      var rows = data.map(function (row) {
        var cells = _this4.generateCells(row);

        return _react2.default.createElement(
          _TableRow2.default,
          { key: 'row-' + row.id },
          cells,
          expandable && _this4.generateExpandedCell(row.id)
        );
      });

      return rows;
    }
  }, {
    key: 'generateCells',
    value: function generateCells(row) {
      var _this5 = this;

      var _state4 = this.state,
          columns = _state4.columns,
          expandedRows = _state4.expandedRows;
      var expandable = this.props.expandable;

      var isExpandable = 'expandedCell' in row;
      var isExpanded = expandedRows.includes(row.id);

      var cells = columns.map(function (column) {
        return _react2.default.createElement(
          _TableCell2.default,
          {
            rowHeader: column.header,
            key: column.key + '-row-' + row.id,
            align: column.align
          },
          row[column.key]
        );
      });

      if (expandable) {
        cells = cells.concat(_react2.default.createElement(
          _TableCell2.default,
          {
            key: 'expandable-cell-' + row.id,
            align: 'right',
            style: { flexBasis: '4rem', flexGrow: '0' }
          },
          isExpandable ? _react2.default.createElement(
            _Button2.default,
            { style: { padding: '0' }, onClick: function onClick() {
                return _this5.handleExpand(row.id);
              } },
            _react2.default.createElement('i', { className: isExpanded ? 'p-icon--minus' : 'p-icon--plus' })
          ) : ''
        ));
      }

      return cells;
    }
  }, {
    key: 'generateExpandedCell',
    value: function generateExpandedCell(rowId) {
      var _state5 = this.state,
          data = _state5.data,
          expandedRows = _state5.expandedRows;

      var _data$find = data.find(function (obj) {
        return obj.id === rowId;
      }),
          expandedCell = _data$find.expandedCell;

      var isExpanded = expandedRows.includes(rowId);

      var classNames = (0, _getClassName3.default)({
        'p-table-expanding__panel': true,
        'u-hide': !expandedCell || !isExpanded
      }) || undefined;

      return _react2.default.createElement(
        _TableCell2.default,
        {
          expandedCell: true,
          style: { borderTop: '0' },
          className: classNames,
          'aria-hidden': !expandedCell || !isExpanded
        },
        expandedCell
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _getClassName;

      var _props3 = this.props,
          className = _props3.className,
          expandable = _props3.expandable,
          hasHeader = _props3.hasHeader,
          sortable = _props3.sortable;


      var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'p-table-expanding', expandable), _defineProperty(_getClassName, 'p-table--sortable', sortable), _getClassName)) || undefined;

      return _react2.default.createElement(
        'table',
        { role: 'grid', className: classNames },
        hasHeader && this.generateHeader(),
        _react2.default.createElement(
          'tbody',
          null,
          this.generateRows()
        )
      );
    }
  }]);

  return Table;
}(_react2.default.Component);

Table.defaultProps = {
  accordion: false,
  children: null,
  className: undefined,
  columns: null,
  data: null,
  expandable: false,
  hasHeader: true,
  sortable: false,
  sortCondition: {}
};

Table.propTypes = {
  accordion: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  columns: _propTypes2.default.arrayOf(_propTypes2.default.object),
  data: _propTypes2.default.arrayOf(_propTypes2.default.object),
  expandable: _propTypes2.default.bool,
  hasHeader: _propTypes2.default.bool,
  sortable: _propTypes2.default.bool,
  sortCondition: _propTypes2.default.object
};

Table.displayName = 'Table';

exports.default = Table;