'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getClassName2 = require('../../utils/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var TableCell = function TableCell(props) {
  var _getClassName;

  var align = props.align,
      ariaSort = props.ariaSort,
      children = props.children,
      className = props.className,
      columnHeader = props.columnHeader,
      role = props.role,
      rowHeader = props.rowHeader,
      otherProps = _objectWithoutProperties(props, ['align', 'ariaSort', 'children', 'className', 'columnHeader', 'role', 'rowHeader']);

  var classNames = (0, _getClassName3.default)((_getClassName = {}, _defineProperty(_getClassName, className, className), _defineProperty(_getClassName, 'u-align--' + align, align), _getClassName)) || undefined;

  if (columnHeader) {
    return _react2.default.createElement(
      'th',
      _extends({
        scope: 'col',
        role: 'columnheader',
        'aria-sort': ariaSort,
        className: classNames
      }, otherProps),
      children
    );
  }

  if (rowHeader) {
    return _react2.default.createElement(
      'th',
      _extends({
        scope: 'row',
        role: 'rowheader',
        className: classNames
      }, otherProps),
      children
    );
  }

  return _react2.default.createElement(
    'td',
    _extends({
      role: role,
      className: classNames
    }, otherProps),
    children
  );
};

TableCell.defaultProps = {
  align: null,
  ariaSort: 'none',
  children: null,
  className: undefined,
  columnHeader: false,
  role: 'gridcell',
  rowHeader: false
};

TableCell.propTypes = {
  align: _propTypes2.default.string,
  ariaSort: _propTypes2.default.string,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  columnHeader: _propTypes2.default.bool,
  role: _propTypes2.default.string,
  rowHeader: _propTypes2.default.bool
};

TableCell.displayName = 'TableCell';

exports.default = TableCell;