'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TabsItem = require('./TabsItem');

var _TabsItem2 = _interopRequireDefault(_TabsItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = function (_React$Component) {
  _inherits(Tabs, _React$Component);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

    _this.toggleSelected = _this.toggleSelected.bind(_this);
    _this.state = {
      selected: props.selected
    };
    return _this;
  }

  _createClass(Tabs, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ selected: nextProps.selected });
    }
  }, {
    key: 'toggleSelected',
    value: function toggleSelected(index) {
      if (this.state.selected !== index) {
        this.setState({ selected: index });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var selected = this.state.selected;
      var children = this.props.children;


      var tabItems = _react2.default.Children.map(children, function (child, index) {
        return _react2.default.cloneElement(child, {
          index: index,
          isSelected: selected === index,
          onClick: _this2.toggleSelected
        });
      });

      return _react2.default.createElement(
        'nav',
        { className: 'p-tabs' },
        _react2.default.createElement(
          'ul',
          { className: 'p-tabs__list', role: 'tablist' },
          tabItems
        )
      );
    }
  }]);

  return Tabs;
}(_react2.default.Component);

Tabs.defaultProps = {
  children: null,
  selected: 0
};

Tabs.propTypes = {
  children: function children(props, propName, componentName) {
    var prop = props[propName];
    var error = null;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type !== _TabsItem2.default) {
        error = new Error(componentName + ' children should be of type "TabsItem".');
      }
    });

    return error;
  },
  selected: _propTypes2.default.number
};

Tabs.displayName = 'Tabs';

exports.default = Tabs;