'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabsItem = function (_React$Component) {
  _inherits(TabsItem, _React$Component);

  function TabsItem() {
    _classCallCheck(this, TabsItem);

    var _this = _possibleConstructorReturn(this, (TabsItem.__proto__ || Object.getPrototypeOf(TabsItem)).call(this));

    _this.onClick = _this.onClick.bind(_this);
    return _this;
  }

  _createClass(TabsItem, [{
    key: 'onClick',
    value: function onClick() {
      var _props = this.props,
          index = _props.index,
          onClick = _props.onClick;

      onClick(index);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          href = _props2.href,
          index = _props2.index,
          isSelected = _props2.isSelected,
          onClick = _props2.onClick;


      return _react2.default.createElement(
        'li',
        { className: 'p-tabs__item', role: 'presentation' },
        _react2.default.createElement(
          'a',
          {
            href: href,
            className: 'p-tabs__link',
            tabIndex: index + 1,
            role: 'tab',
            'aria-controls': 'tab-' + index,
            'aria-selected': isSelected,
            onClick: this.onClick,
            onKeyPress: function onKeyPress(event) {
              return event.key === 'Enter' && onClick(index);
            }
          },
          children
        )
      );
    }
  }]);

  return TabsItem;
}(_react2.default.Component);

TabsItem.defaultProps = {
  href: null,
  index: 0,
  isSelected: false,
  onClick: function onClick() {
    return 1;
  }
};

TabsItem.propTypes = {
  children: _propTypes2.default.node.isRequired,
  href: _propTypes2.default.string,
  index: _propTypes2.default.number,
  isSelected: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

TabsItem.displayName = 'TabsItem';

exports.default = TabsItem;