'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ToolTip = function ToolTip(_ref) {
  var id = _ref.id,
      message = _ref.message,
      position = _ref.position,
      children = _ref.children;

  var modifierClassPrefix = 'p-tooltip--';

  var className = 'p-tooltip';

  if (position) {
    className += ' ' + modifierClassPrefix + position;
  }

  return _react2.default.createElement(
    'span',
    { className: className, 'aria-describedby': id },
    children,
    _react2.default.createElement(
      'span',
      { className: 'p-tooltip__message', role: 'tooltip', id: id },
      message
    )
  );
};

ToolTip.defaultProps = {
  position: 'btm-right'
};

ToolTip.propTypes = {
  children: _propTypes2.default.node.isRequired,
  position: _propTypes2.default.oneOf(['left', 'right', 'top-left', 'btm-left', 'top-right', 'btm-right', 'top-center', 'btm-center']),
  id: _propTypes2.default.string.isRequired,
  message: _propTypes2.default.string.isRequired
};

ToolTip.displayName = 'ToolTip';

exports.default = ToolTip;